models/Fotografo.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "fotografo".
 *
 * @property int $idf
 * @property string $nombre
 * @property string $alias
 *
 * @property Email[] $emails
 * @property Picture[] $pictures
 */
class Fotografo extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'fotografo';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nombre', 'alias'], 'string', 'max' => 63],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'idf' => 'Idf',
            'nombre' => 'Nombre',
            'alias' => 'Alias',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getEmails()
    {
        return $this->hasMany(Email::className(), ['idf' => 'idf']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getPictures()
    {
        return $this->hasMany(Picture::className(), ['idf' => 'idf']);
    }
    
    public function getNoticias(){
        return $this->hasMany(Noticia::className(),['idn'=>'idn'])->viaTable('picture', ['idf'=>'idf']);
    }
    
    public function getAutores(){
        return $this->hasMany(Autor::className(),['ida'=>'ida'])->via('noticias');
    }
}

controllers/FotografoController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Fotografo;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * FotografoController implements the CRUD actions for Fotografo model.
 */
class FotografoController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    
    
    
        public function actionConsultaemail($id)
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::findone($id)->getFotografos()
            ]);
        return $this->render('listaemails', [
            'dataProvider' => $dataProvider,
            'autor'=> Fotografo::findone($id)->nombre,
        ]);
    }
    
    
    
    
    
    
    /**
     * Lists all Fotografo models.
     * @return mixed
     */
    public function actionList()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::find(),
            
             'pagination' => [
        'pageSize' => 4,]
        ]);

        return $this->render('listview', [
            'dataProvider' => $dataProvider,
            
        ]);
    }

    /**
     * Lists all Fotografo models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Fotografo model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Fotografo model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Fotografo();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idf]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Fotografo model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->idf]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Fotografo model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Fotografo model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Fotografo the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Fotografo::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionConsultarpictures($id){
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::findone($id)->getPictures(),
            'pagination' => [
        'pageSize' => 4,
    ],
            
            ]);
        return $this->render('listapictures', [
            'dataProvider' => $dataProvider,
            'fotografo'=> Fotografo::findone($id)->nombre,
        ]);
               
        
        
    }
    
    
    /*
     * 
     * lista las noticias del fotografo
     */
        public function actionConsultarnoticias($id){
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::findone($id)->getNoticias(),
            'pagination' => [
        'pageSize' => 4,
    ],
            
            ]);
        return $this->render('listarnoticias', [
            'dataProvider' => $dataProvider,
            'fotografo'=> Fotografo::findone($id)->nombre,
        ]);
               
        
        
    }
    
     /*
     * 
     * lista las noticias Autores
     */
        public function actionConsultarautores($id){
        $dataProvider = new ActiveDataProvider([
            'query' => Fotografo::findone($id)->getAutores(),
            'pagination' => [
        'pageSize' => 4,
    ],
            
            ]);
        return $this->render('listarautores', [
            'dataProvider' => $dataProvider,
            'fotografo'=> Fotografo::findone($id)->nombre,
        ]);
               
        
        
    }

    

}

views/fotografo/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Fotografo */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="fotografo-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'alias')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/fotografo/_listar.php
<?php
use yii\helpers\Html;
use yii\helpers\ArrayHelper;
?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
      <div class="caption">
        <h2><?= $model->idf.' ' ?><?= $model->nombre ?> </h2>
        
        <p >
            <?= Html::a('PortFolio', 'https://www.pinterest.es/', ['class' => 'btn btn-primary'], ['target' => '_blank']);?>
           <?= Html::a('Fotos', ['fotografo/consultarpictures','id'=>$model->idf], ['class' => 'btn btn-primary']);?>
        </p>
        <p >
            <?= Html::a('Noticias', ['fotografo/consultarnoticias', 'id'=>$model->idf ], ['class' => 'btn btn-primary']);?>
            <?= Html::a('Autores', ['fotografo/consultarautores', 'id'=>$model->idf ], ['class' => 'btn btn-primary']);?>
            
        </p>
        <p>
            <?php 
            $correos=ArrayHelper::getColumn($model->emails, "email");
            $correos= implode(" , ", $correos);
            ?> 
            
            <?= $correos ?>
        </p>
    </div>
  </div>

views/fotografo/_listarautores.php
<?php
use yii\helpers\Html;
?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
      <div class="caption">
         <p><?php
         
         
         echo $model->nombre.'</br>';
         echo $model->alias;
         
                 
                 ?> </p>
         
                
    </div>
  </div>

views/fotografo/_listarfotos.php
<?php
use yii\helpers\Html;
?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
      <div class="caption">
         <p><?php
         
         echo Html::img( '@web/imgs/'.$model->foto,['class'=>'img-thumbnail']);
         echo $model->foto.'</br>';
         
                 
                 ?> </p>
         
                
    </div>
  </div>

views/fotografo/_listarnoticias.php
<?php
use yii\helpers\Html;
?>
<div class="col-sm-4 col-md-6">
    <div class="thumbnail">
      <div class="caption">
         <p><?php
         
         
         echo $model->titulo.'</br>';
         echo $model->texto;
         
                 
                 ?> </p>
         
                
    </div>
  </div>

views/fotografo/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Fotografo */

$this->title = 'Create Fotografo';
$this->params['breadcrumbs'][] = ['label' => 'Fotografos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="fotografo-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/fotografo/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Fotografos';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="fotografo-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Fotografo', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'idf',
            'nombre',
            'alias',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/fotografo/listapictures.php
<div>
<h3>Fotógrafos/Fotos/ </h3>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
echo '<h1>'.'Fotos de '.$fotografo.'</h1>';  
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listarfotos', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/fotografo/listarautores.php
<div>
<h3>Fotógrafos/Autores/ </h3>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
echo '<h1>'.'Noticias de '.$fotografo.'</h1>';  
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listarautores', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/fotografo/listarnoticias.php
<div>
<h3>Fotógrafos/Noticias/ </h3>
</div>

<div class="row">
<?php
use yii\widgets\ListView;
echo '<h1>'.'Noticias de '.$fotografo.'</h1>';  
/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listarnoticias', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
]);
?>
</div>

views/fotografo/listview.php
<div>
<h3>Fotógrafos/ </h3>
</div>

<div class="row">
<?php
use yii\widgets\ListView;

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar', /*Recomendado _ el guion  que se muestra una vista dentro de otra */
    'layout'=>"{summary}\n{pager}\n{items}"
]);
?>
</div>

views/fotografo/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Fotografo */

$this->title = 'Update Fotografo: ' . $model->idf;
$this->params['breadcrumbs'][] = ['label' => 'Fotografos', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->idf, 'url' => ['view', 'id' => $model->idf]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="fotografo-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/fotografo/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Fotografo */

$this->title = $model->idf;
$this->params['breadcrumbs'][] = ['label' => 'Fotografos', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="fotografo-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->idf], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->idf], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'idf',
            'nombre',
            'alias',
        ],
    ]) ?>

</div>